clear all;
close all;
clc;

l = 0.8;
x0 = [0 0.1 0 0].';
Ts = 0.05;
input.Ts = Ts;
input.nSteps = 3;

load lqr.mat A B Q R K P

time = 0;
Tf = 5;
state_sim = x0;
state_lin = x0;
iter = 0;
while time(end) < Tf
    % optimal feedback law (open loop), TODO: close the loop
%     u_LQR = -K*state_lin(:,end);
    u_LQR = -K*state_sim(:,end);
    
    % apply control to nonlinear system
    input.x = state_sim(:,end);
    input.u = u_LQR;
    output = RK4_integrator( @ode, input );
    state_sim(:,end+1) = output.value;
    
    % linear system
    state_lin(:,end+1) = A*state_lin(:,end) + B*u_LQR;
    
    % next time step and visualize result
    iter = iter+1;
    time(end+1) = iter*Ts;
    visualize(time, state_sim, l);
    
    pause(Ts/2);
end